include('particletrace.lua')

local sndAttackLoop = Sound("Weapon_FlameThrower.FireLoop")
local sndSprayLoop = Sound("Weapon_FlameThrower.FireLoop")
local sndAttackStop = Sound("ambient/_period.wav")
local sndIgnite = Sound("Fire.Engulf")

if (SERVER) then

	AddCSLuaFile( "shared.lua" )
	SWEP.Weight				= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false
	
	SWEP.HoldType			= "smg"

end

if ( CLIENT ) then

	SWEP.DrawAmmo			= true
	SWEP.DrawCrosshair		= true
	SWEP.ViewModelFOV		= 64
	SWEP.ViewModelFlip		= false
	SWEP.CSMuzzleFlashes	= false
	
	
	SWEP.PrintName			= "TF2 Flamethrower"			
	SWEP.Author				= "Ancient Coffee Bean"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 10

end

SWEP.Author			= "Ancient Coffee Bean"
SWEP.Contact		= ""
SWEP.Purpose		= ""
SWEP.Instructions	= ""
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= false

SWEP.ViewModel			= "models/weapons/v_models/v_flamethrower_pyro.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_flamethrower.mdl"

SWEP.Primary.Recoil			= 0
SWEP.Primary.Damage			= 3
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.02
SWEP.Primary.Delay			= 0.05

SWEP.Primary.ClipSize		= 200
SWEP.Primary.DefaultClip	= 200
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "pistol"

SWEP.Secondary.Recoil			= 0
SWEP.Secondary.Damage			= 3
SWEP.Secondary.NumShots		= 1
SWEP.Secondary.Cone			= 0.02
SWEP.Secondary.Delay			= 0.05

SWEP.Secondary.ClipSize		= 0
SWEP.Secondary.DefaultClip	= 0
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"


function SWEP:Initialize()

	if ( SERVER ) then
		self:SetWeaponHoldType( self.HoldType )
	end
	
	self.EmittingSound = false
	
	util.PrecacheModel("models/player/charple01.mdl")

end

function SWEP:Reload()
	self.Weapon:DefaultReload( ACT_VM_RELOAD )
	self:StopSounds()
end

function SWEP:Think()

	if self.Owner:KeyReleased(IN_ATTACK) or self.Owner:KeyReleased(IN_ATTACK2) then
		self:StopSounds()
	end

end

function SWEP:PrimaryAttack()

	local curtime = CurTime()
	local InRange = false

	self.Weapon:SetNextSecondaryFire( curtime + 0.8 )
	self.Weapon:SetNextPrimaryFire( curtime + self.Primary.Delay )
	
	if not self:CanPrimaryAttack() or self.Owner:WaterLevel() > 1 then 
	self:StopSounds() 
	return end
	
	if not self.EmittingSound then
		self.Weapon:EmitSound(sndAttackLoop)
		self.EmittingSound = true
	end
	
	self:TakePrimaryAmmo(1)
	
	--if SERVER then
		local PlayerVel = self.Owner:GetVelocity()
		local PlayerPos = self.Owner:GetShootPos()
		local PlayerAng = self.Owner:GetAimVector()
		
		local trace = {}
		trace.start = PlayerPos
		trace.endpos = PlayerPos + (PlayerAng*4096)
		trace.filter = self.Owner
		
		local traceRes = util.TraceLine(trace)
		local hitpos = traceRes.HitPos
		
		local jetlength = (hitpos - PlayerPos):Length()
		if jetlength > 568 then jetlength = 568 end
		if jetlength < 6 then jetlength = 6 end
		
		if self.Owner:Alive() then
			local effectdata = EffectData()
			effectdata:SetOrigin( hitpos )
			effectdata:SetEntity( self.Weapon )
			effectdata:SetStart( PlayerPos )
			effectdata:SetNormal( PlayerAng )
			effectdata:SetScale( jetlength )
			effectdata:SetAttachment( 1 )
			util.Effect( "flamepuffs", effectdata )
		end

		if self.DoShoot then

			local ptrace = {}
			ptrace.startpos = PlayerPos + PlayerAng:GetNormalized()*16
			local ang = (traceRes.HitPos - ptrace.startpos):GetNormalized()
			ptrace.func = burndamage
			ptrace.movetype = MOVETYPE_FLY
			ptrace.velocity = ang*728 + 0.5*PlayerVel
			ptrace.model = "none"
			ptrace.filter = {self.Owner}
			ptrace.killtime = (jetlength + 16)/ptrace.velocity:Length()
			ptrace.runonkill = false
			ptrace.collisionsize = 14
			ptrace.worldcollide = true
			ptrace.owner = self.Owner
			ptrace.name = "flameparticle"
			ParticleTrace(ptrace)
			
			self.DoShoot = false
			else
			self.DoShoot = true
		end
	--end
end

function SWEP:SecondaryAttack()

	local curtime = CurTime()

	self.Weapon:SetNextSecondaryFire( curtime + self.Primary.Delay )
	self.Weapon:SetNextPrimaryFire( curtime + 1 )
	
	if not self:CanSecondaryAttack() or self.Owner:WaterLevel() > 1 then 
	self:StopSounds() 
	return end
	
	if not self.EmittingSound then
		self.Weapon:EmitSound(sndSprayLoop)
		self.EmittingSound = true
	end
	
	self:TakePrimaryAmmo(1)
	
	local PlayerVel = self.Owner:GetVelocity()
	local PlayerPos = self.Owner:GetShootPos()
	local PlayerAng = self.Owner:GetAimVector()
	
	local trace = {}
	trace.start = PlayerPos
	trace.endpos = PlayerPos + (PlayerAng*4096)
	trace.filter = self.Owner
	
	local traceRes = util.TraceLine(trace)
	local hitpos = traceRes.HitPos
	
	local jetlength = (hitpos - PlayerPos):Length()
	
		if jetlength > 568 then 
		jetlength = 568
		elseif self.DoShoot then
	
		local normal = traceRes.HitNormal

			if traceRes.HitNonWorld then
				local hitent = traceRes.Entity
				local enttype = hitent:GetClass()
				if hitent:IsNPC() or hitent:IsPlayer() or enttype == "prop_physics" or enttype == "prop_vehicle" then
					local hitenttable = hitent:GetTable()
					hitenttable.FuelLevel = hitenttable.FuelLevel or 0
					hitenttable.FuelLevel = hitenttable.FuelLevel + 1
					util.Decal("BeerSplash", hitpos + normal, hitpos - normal )
				end
			elseif Vector(0,0,1):Dot(normal) > 0.25 then --...
				if SERVER then
					local fire = ents.Create("sent_firecontroller") --ignitable fire.
					fire:SetPos(hitpos + normal*16)
					fire:SetOwner(self.Owner)
					fire:Spawn()
				end
				util.Decal("BeerSplash", hitpos + normal, hitpos - normal )
			end
			
			if SERVER then
				for key,found in pairs(ents.FindInSphere(hitpos,32)) do
					local foundname = found:GetName()
					
					if found:GetClass() == "entityflame"
					or found:GetName() == "BurningFire"
					or found:GetName() == "flameparticle" then --teh Bomb...
					
					explode(self.Owner,PlayerPos) --Then blow ourselves up.

						for i=1,7 do --Spawn some fires corpse.
							local fire = ents.Create("env_fire")
							local randvec = Vector(math.random(-150,150),math.random(-150,150),0)

							fire:SetKeyValue("StartDisabled","0")
							fire:SetKeyValue("health",math.random(29,31))
							fire:SetKeyValue("firesize",math.random(64,72))
							fire:SetKeyValue("fireattack","2")
							fire:SetKeyValue("ignitionpoint","0")
							fire:SetKeyValue("damagescale","35")
							fire:SetKeyValue("spawnflags",2 + 4 + 128)
							
							fire:SetPos(PlayerPos + randvec)
							fire:SetOwner(self.Owner)
							fire:Spawn()
							fire:Fire("StartFire","","0")
						end
					
					break
					
					end
			
				end
				
			end
			
		self.DoShoot = false
		else
		self.DoShoot = true
		end

	if jetlength < 6 then jetlength = 6 end

	local effectdata = EffectData()
	effectdata:SetEntity( self.Weapon )
	effectdata:SetStart( PlayerPos )
	effectdata:SetNormal( PlayerAng )
	effectdata:SetScale( jetlength )
	effectdata:SetAttachment( 1 )
	util.Effect( "gaspuffs", effectdata )
	
end


HumanModels = {

"models/Humans/",
"models/player/",
"models/zombie",
"[Pp]olice.mdl",
"[Ss]oldier",
"[Aa]lyx.mdl",
"[Bb]arney.mdl",
"[Bb]reen.mdl",
"[Ee]li.mdl",
"[Mm]onk.mdl",
"[Kk]leiner.mdl",
"[Mm]ossman.mdl",
"[Oo]dessa.mdl",
"[Gg]man"

}

function IsHumanoid(ent)

if ent:IsPlayer() then return true end

local entmodel = ent:GetModel()

	for k,model in pairs(HumanModels) do
		if string.find(entmodel,model) ~= nil then
		return true end
	end
	
	return false
	
end

function explode(ent,pos)

	pos.z = pos.z - 64

	Immolate(ent,pos)
	
	local boom = ents.Create("env_explosion")
	boom:SetKeyValue("iMagnitude","384")
	boom:SetPos(pos)
	boom:SetOwner(ent)
	boom:Spawn()
	
	boom:Fire("Explode","","0")

	local effectdata = EffectData()
	effectdata:SetOrigin( pos )
	util.Effect( "explosion_large", effectdata )
	

end

function Immolate(ent,pos)

pos = pos or ent:GetPos()


	if SERVER then
		ent:SetModel("models/player/charple01.mdl")
		
		if ent:IsPlayer() then
			ent:Kill()
		else
			ent:Fire("sethealth","0","0")
		end
	end
	
	local effectdata = EffectData()
	effectdata:SetOrigin( pos )
	util.Effect( "immolate", effectdata )


end

function burndamage(ptres)

	local hitent = ptres.activator
	if hitent:WaterLevel() > 0 then return end

	local ttime = ptres.time
	if ttime == 0 then ttime = 0.1 end --Division by zero is FANTASTIC
	
	local damage = math.ceil(3/ttime)
	if damage > 15 then damage = 15 end
	
	local radius = math.ceil(256*ttime)
	if radius < 16 then radius = 16 end
	

	local healthpercent = 3
	local isnpc = hitent:IsNPC()
	local enthealth = 1
	local enttable = hitent:GetTable()
	
	if isnpc or hitent:IsPlayer() then
	enthealth = hitent:Health()
	healthpercent = math.ceil(enthealth/5)
	end
	
	local fuel = enttable.FuelLevel
	if fuel and fuel > 0 then
	
	ptres.caller:EmitSound(sndIgnite)
	enttable.FuelLevel = 0
	
	local entpos = hitent:GetPos()
	local boompos = entpos
	boompos.z = boompos.z + hitent:BoundingRadius()/2
	local damagemult = 4*fuel
	local radiusmult = radius + fuel
	
	local effectdata = EffectData()
	effectdata:SetOrigin( entpos )
	effectdata:SetEntity( hitent )
	effectdata:SetStart( entpos )
	effectdata:SetNormal( Vector(0,0,1) )
	effectdata:SetScale( 10 )
	util.Effect( "HelicopterMegaBomb", effectdata )
	
		if damagemult < enthealth then
			hitent:Ignite(math.Rand(7,11),0)
			hitent:SetHealth(24 + damagemult)
			util.BlastDamage(ptres.owner:GetActiveWeapon(), ptres.owner, boompos, radiusmult, damagemult)
		elseif IsHumanoid(hitent) then
			Immolate(hitent,entpos)
			else
			
			util.BlastDamage(ptres.owner:GetActiveWeapon(), ptres.owner, boompos, radiusmult, damagemult)
			hitent:SetHealth(0)

		end
		
	else
	
	util.BlastDamage(ptres.owner:GetActiveWeapon(), ptres.owner, ptres.particlepos, radius, damage)

		local reverselottery = math.random(0,healthpercent)
		if reverselottery == 1 then --it's your lucky day!
		hitent:Ignite(math.Rand(7,11),0)
			if isnpc and enthealth < 32 and hitent:GetMaxHealth() > 24 then
			hitent:SetHealth(32) --burn timer
			end
		end
	end
end

function DeFlamitize(ply) 
   
ply:GetTable().FuelLevel = 0

if ply:IsOnFire() then
	ply:Extinguish()
end
   
end 
   
 hook.Add( "PlayerDeath", "deflame", DeFlamitize )


function SWEP:StopSounds()
	if self.EmittingSound then
		self.Weapon:StopSound(sndAttackLoop)
		self.Weapon:StopSound(sndSprayLoop)
		self.Weapon:EmitSound(sndAttackStop)
		self.EmittingSound = false
	end	
end


function SWEP:Holster()
	self:StopSounds()
	return true
end

function SWEP:OnRemove()
	self:StopSounds()
	return true
end


