

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
	SWEP.HoldType			= "shotgun"
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "TF2 Engineer Shotgun"
	SWEP.ViewModelFOV		= 61
	SWEP.DrawCrosshair 	= true			
	SWEP.Author				= "Ancient Coffee Bean"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 3
	SWEP.IconLetter			= ""
	
	killicon.AddFont( "weapon_tf2_shotgun", "HL2KillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


SWEP.Base				= "weapon_tf2_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_shotgun_engineer.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_shotgun.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.ForceApply				= 5 -- Amount of force to give to phys objects
SWEP.TracerFreq				= 2 -- Show a tracer on every x bullets 

SWEP.Primary.Sound			= Sound( "Weapons/shotgun_shoot.wav" )
SWEP.Primary.Recoil			= 0.0
SWEP.Primary.RecoilXRand	= 0.0
SWEP.Primary.RecoilYRand	= 0.0
SWEP.Primary.Damage			= 9
SWEP.Primary.NumShots		= 7
SWEP.Primary.Cone			= 0.07
SWEP.Primary.ClipSize		= 8
SWEP.Primary.Delay			= 0.7
SWEP.Primary.DefaultClip	= 75
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "buckshot"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

-- All these functions are needed because of the complex reloading style on the shotgun
function SWEP:PrimaryAttack()

	self.BreakReload = true
	self.IsReloading = false

	self.Weapon:SetNextSecondaryFire( CurTime() + self.Primary.Delay )
	self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
	
	if ( !self:CanPrimaryAttack() ) then return end
	
	// Play shoot sound
	self.Weapon:EmitSound( self.Primary.Sound )
	
	// Shoot the bullet
	self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone )
	
	// Remove 1 bullet from our clip
	self:TakePrimaryAmmo( 1 )
	
	// Punch the player's view
	self.Owner:ViewPunch( Angle( math.Rand(self.Primary.RecoilXRand,-self.Primary.RecoilXRand) * self.Primary.Recoil, math.Rand(self.Primary.RecoilYRand,-self.Primary.RecoilYRand) *self.Primary.Recoil, 0 ) )
	
	self.IsReloading = true -- Simple hack so we must pump once before reloading
	timer.Simple(0.3, function() self.Weapon:SendWeaponAnim( ACT_SHOTGUN_PUMP ) end)
	timer.Simple(0.3, function() self.Weapon:EmitSound("Weapon_Shotgun.Special1") end)
	timer.Simple(0.3, function() self.IsReloading = false end)
	
end

function SWEP:StartReload()
	if ( self.BreakReload ) then return end
	
	self.Weapon:SendWeaponAnim( ACT_VM_RELOAD )
	self.Weapon:SetClip1(self.Weapon:Clip1() + 1)
	self.Weapon:EmitSound("Weapon_Shotgun.Reload")
	if (self.Weapon:Clip1() ~= 6) then
	timer.Simple(0.4,  function() self:StartReload() end)
	else
	self.IsReloading = false
	timer.Simple(0.2, function() self.Weapon:SendWeaponAnim( ACT_SHOTGUN_RELOAD_FINISH ) end)
	end
end

function SWEP:Reload()
	self:SetIronsights( false )
	if ( SERVER ) then self.Owner:CrosshairEnable() end
	
	if (self.Weapon:Clip1() ~= 6) then
		if ( not self.IsReloading ) then
			timer.Simple(0.2, function() self:StartReload() end)
			self.Weapon:SendWeaponAnim( ACT_SHOTGUN_RELOAD_START )
		end
		self.BreakReload = false
		self.IsReloading = true
		return false
	end
	self.Weapon:DefaultReload( ACT_VM_RELOAD )
	self.IsReloading = false
end